set -e
set -x

(cd origin && node install/install.js ..)
# mv origin/node_modules react/
(cd react && yarn add roderic)

# prod build & launch
(cd react && yarn prod)
(cd react && node servers/index.js killme & disown)

# install puppeteer npm and delay for server to run
(cd puppeteer && yarn)

# test if server is online
ifconfig
(curl "$(/bin/bash puppeteer/docker/hostip.sh):$(node puppeteer/configReader.js --param servers.docssh.port)/endpoint/page?lang=test")

# test server
(cd puppeteer/ && make ts)
sleep 2

# testing test server
(cd puppeteer/ && make tst)
(cd puppeteer && curl "0.0.0.0$(/bin/bash colon.sh)$(node configReader.js --param NODE_SSR_PORT)/page?lang=test")

# testing in prod mode
(cd puppeteer && /bin/bash test.sh --target docssh)
(cd react && /bin/bash kill.sh killme)

# dev build & launch
(cd react && yarn yarn devnowatch)
(cd react && node servers/index.js killme & disown)

# testing in dev mode
(cd puppeteer && /bin/bash test.sh --target docssh)
(cd react && /bin/bash kill.sh killme)

