
import isArray from 'lodash/isArray';

// import size from 'lodash/size';

// function isArray(obj) {
//     return Object.prototype.toString.call(obj) === '[object Array]';
// };

const access = (source, value, operationType, localtmp, kt) => {

    // log(
    //     'access', JSON.stringify(source, null, 4),
    //     'value:', JSON.stringify(value, null, 4),
    //     'ot:', JSON.stringify(operationType, null, 4),
    //     'lt:', JSON.stringify(localtmp, null, 4),
    //     'kt:', JSON.stringify(kt, null, 4)
    // );

    if (typeof operationType === 'function') {

        operationType(source, value);
    }
    else {

        switch (operationType) {
            case 'push': // add to array to the end
            {
                const tmp = [...localtmp[kt]];

                tmp.push(value);

                localtmp[kt] = tmp;
            }
                break;
            case 'unshift': // add to array at the beginning
            {
                const tmp = [...localtmp[kt]];

                tmp.unshift(value);

                localtmp[kt] = tmp;
            }
                break;
            case 'press': // add to array, under specific index
            {
                const tmp = [...localtmp[kt]];

                const index = (value.index < 0) ? 0 : value.index;

                tmp.splice(index, 0, value.value);

                localtmp[kt] = tmp;
            }
                break;
            case 'index': // replace element by under given index

            {
                const tmp = [...localtmp[kt]];

                const index = (value.index < 0) ? 0 : value.index;

                tmp.splice(index, 1, value.value);

                localtmp[kt] = tmp;
            }
                break;
            case 'unindex': // delete
            {
                const tmp = [...localtmp[kt]];

                tmp.splice(value, 1);

                localtmp[kt] = tmp;
            }
                break;
            case 'reindex': // reorder element in the array - move to different position
            {
                const tmp = [...localtmp[kt]];

                var t = tmp[value.oldIndex];

                tmp.splice(value.oldIndex, 1);

                tmp.splice(value.newIndex, 0, t);

                localtmp[kt] = tmp;
            }
                break;
            default:

                localtmp[kt] = value;

                break;
        }
    }

    return localtmp[kt];
}

export const edit = (source, key, value, operationType) => {

    if (typeof key === 'string') {

        key = key.split('.');
    }

    if (typeof key !== 'string' && ! key ) {

        key = [];
    }

    if ( ! isArray(key) ) {

        key = [key];
    }

    if (key.length) {

        let tmp = source, kt;

        while (key.length) {

            let localtmp = tmp;

            kt = key.shift();

            tmp = tmp[kt];

            if ( ! key.length ) {

                return access(tmp, value, operationType, localtmp, kt);
            }
        }
    }
    else {

        return access(source, value, operationType)
    }
};

// var size = (function () {
//
//     function isArray(obj) {
//         return Object.prototype.toString.call(obj) === '[object Array]';
//     };
//
//     function isObject(a) {
//         return (!!a) && (a.constructor === Object); // array or function is not object according to this test
//         // return Object.prototype.toString.call(a) === '[object Object]'; // better in node.js to dealing with RowDataPacket object
//         // return ['[object Object]',"[object Array]"].indexOf(Object.prototype.toString.call(a)) > -1;
//     };
//
//     return t => {
//
//         if (isArray(t)) {
//
//             return t.length;
//         }
//
//         if (isObject(t)) {
//
//             return Object.keys(t).length;
//         }
//
//         return 0;
//     }
// }());

/**
 *
 * @param source
 * @param key
 * @param jsonIfNotString - for grabbing errors mode - get all but serialized you can then
 * query again with more direct path
 * @returns {*}
 */
export const get = (source, key, ...rest) => {
// var get = (source, key, ...rest) => {

    try {

        if (typeof key === 'string') {

            key = key.split('.');
        }

        if ( ! key ) {

            return source;
        }

        if ( ! isArray(key) ) {

            key = [key];
        }

        if (key.length) {

            let tmp = source, kt;

            while (key.length) {

                kt = key.shift();

                if (typeof tmp[kt] === 'undefined') {

                    throw '';
                }

                tmp = tmp[kt];

                if ( ! key.length ) {

                    return tmp;
                }
            }
        }

        return source;
    }
    catch (e) {
    }

    if (rest.length) {

        return rest[0];
    }
}
