/**
 * Script to use only on server, never import it to browser script
 */

var publicConfig = require('public.config');

var serverConfig = require('server.config');

if (!publicConfig.jwt.cookie_name) {

    throw "publicConfig.jwt.cookie_name is not specified";
}

if (!serverConfig.jwt.cookie_expire_after) {

    throw "serverConfig.jwt.cookie_expire_after is not specified";
}

if (serverConfig.jwt.cookie_expire_after < 1) {

    throw "serverConfig.jwt.cookie_expire_after is too small";
}

var Cookies = require('cookies');

module.exports = function (req, res) {

    var cookies = new Cookies(req, res);

    return {
        get: function () {

            // console.log(`\n\nget cookie...\n\n`);

            return cookies.get(publicConfig.jwt.cookie_name)
        },
        /**
         * @param value - string value
         * @param expires - milisecond (+ or - if you want to delete) https://github.com/pillarjs/cookies#cookiesget-name--options--
         * @returns {tool}
         */
        set: function (value) {

            // console.log(`\n\nset cookie...\n\n`);

            cookies.set(publicConfig.jwt.cookie_name, value, {
                expires: (function (k) {
                    k.setTime(k.getTime() + (serverConfig.jwt.cookie_expire_after * 1000))
                    return k;
                }(new Date())),
                httpOnly: false
            });

            return this;
        },
        del: function () {
            return this.set('delete-this-cookie', - (1 * 60 * 60 * 1000) ) // -1 day
        }
    }
};

