/**
 *

 onurlchange(url => console.log('onchange', url))

 history.pushState({}, "page 2", "bar.test");

 history.pushState({}, "page 2", "bar.htmlds4");
 setTimeout(() => history.pushState({}, "page 2", "bar.htmlds24"), 400) // trigger once

 history.pushState({}, "page 2", "bar.htmlds");
 setTimeout(() => history.pushState({}, "page 2", "bar.htmlds2"), 1100) // trigger twice

 history.pushState({}, "page 2", "bar.htmlds");
 setTimeout(() => history.pushState({}, "page 2", "bar.htmlds2"), 1100)
 setTimeout(() => history.pushState({}, "page 2", "bar.htmlds"), 2300) // trigger 3 times


 history.pushState({}, "page 2", "bar.htmlds5");
 setTimeout(() => history.pushState({}, "page 2", "bar.htmlds25"), 1100)
 setTimeout(() => history.pushState({}, "page 2", "bar.htmlds5"), 1300) // trigger 3 times

 */
(function (root, factory, name, tmp) {

    var log=(function(){try{return console.log}catch(e){return function (){}}}());

    var node = typeof global !== 'undefined' && Object.prototype.toString.call(global.process) === '[object process]';

    try {
        // Browser globals
        tmp = root[name] = root[name] || factory(root, log, node);
    }
    catch (e) {
    }

    if (typeof module === 'object' && module.exports) {
        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        module.exports = tmp || factory({}, log, node);
    }

}(typeof window !== 'undefined' ? window : (typeof self !== 'undefined' ? self : this), function (root, log, node) {

    var stack = [], handler = false, id = 1;

    function inc() {
        id += 1;
        if (id > 1000) {
            id = 1;
        }
        return id;
    }

    function trigger(href) {

        for (var i = 0, l = stack.length ; i < l ; i += 1 ) {

            stack[i](href);
        }
    }

    function start(onInit) {

        if (node) {

            // log('this is node environment');

            return tool;
        }

        if (handler) {

            // log('already working');

            return tool;
        }

        // log('starting...');

        var tmp = false;

        function check(t) {

            if (tmp === false) {

                tmp = location.href;

                if (onInit === true) {

                    return trigger();
                }
            }

            t = location.href;

            if (tmp !== t) {

                var locid = inc();

                // log('locid', locid)

                setTimeout(() => {

                    // log('locid=id', locid, id)
                    // log('urleq: ', t, location.href)

                    if (handler && locid === id && t === location.href) {

                        trigger(tmp = t);
                    }

                }, 500);
            }
        };

        check();

        handler = setInterval(check, 1000);
    };

    function stop() {

        if ( ! handler ) {

            // log('already not stopped');

            return tool;
        }

        // log('stopping...');

        clearInterval(handler);

        handler = false;

        return tool;
    };

    var tool = (fn, onInit) => {

        if (node) {

            // log('this is node environment');

            return tool;
        }

        stack.find(tmp => tmp === fn) || stack.push(fn);

        if (stack.length > 0) {

            start(onInit);
        }

        return tool;
    };

    tool.unsubscribe = fn => {

        if (node) {

            // log('this is node environment');

            return tool;
        }

        stack = stack.filter(tmp => fn !== tmp);

        if (stack.length < 1) {

            stop();
        }

        return tool;
    }

    tool.start  = start;
    tool.stop   = stop;

    // log('return ', tool)
    return tool;
}, 'onurlchange'));

