
import React, { Component, Fragment } from 'react';

import { createPortal } from 'react-dom';

import isArray from 'lodash/isArray';

import PropTypes from 'prop-types';

// const log = () => {};

/**
 * It turned out that this is useless junk if you need it in IE
 * if you submit form in iframe and receive response, from that
 * moment cross origin policy is ON and you have no access to iframe content
 *
 * ... there is still possiblity to bind onload and just request for result in separate ajax request
 * better this then nothing...
 *
 * https://hackernoon.com/using-a-react-16-portal-to-do-something-cool-2a2d627b0202
 * https://reactjs.org/docs/portals.html
 */
export default class Iframe extends Component {
    static cls = 'react-iframe';
    static propTypes = {
        beforeAttach: PropTypes.func,
        css: PropTypes.oneOfType([
            PropTypes.string,
            PropTypes.arrayOf(PropTypes.string),
        ]),
    }
    constructor(...args) {

        super(...args);

        this.state = {}
    }
    setRef = ref => {

        // log('setRef', ref);

        this.ref        = ref;

        this.div        = false;

        const callback = () => {
            try {

                if (ref.contentDocument || ref.contentWindow.document) {

                    clearInterval(handler);

                    this.forceUpdate();
                }
            }
            catch (e) {

                // log(`can't find document`);
            }
        };

        callback();

        const handler = setInterval(callback, 100);
    }
    render () {

        // log('render...');

        const document = (function (ref) {

            if (ref) {

                return ref.contentDocument || ref.contentWindow.document;
            }

        }(this.ref));

        // log('render test: ref: ', this.ref, 'loc document: ', document);

        let {
            css,
            beforeAttach,
            ...props
        } = this.props;

        if (typeof beforeAttach !== 'function') {

            beforeAttach = () => {}
        }

        if ( typeof css === 'string' ) {

            css = [ css ];
        }

        if ( ! isArray(css) ) {

            css = [];
        }

        // log('render, before attempt', document);

        if (document) {

            // log('attepmt to create div: ', document, this.div);

            this.div = (function (doc, div, b) {

                if ( div ) {

                    // log('found previous/ div')
                }
                else {

                    // log('before create event')

                    beforeAttach(doc);

                    // log('try to create');

                    div = doc.createElement('div');

                    div.setAttribute('class', Iframe.cls);

                    b.appendChild(div);

                    if (css.length) {

                        const head = doc.getElementsByTagName('head')[0];

                        css.forEach(c => {
                            const link = doc.createElement('link');
                            link.setAttribute('rel', 'stylesheet');
                            link.setAttribute('type', 'text/css');
                            link.setAttribute('href', c);
                            head.appendChild(link);
                        });
                    }
                }

                return div;

            }(document, document.querySelector('.' + Iframe.cls), document.querySelector('body')));

            // setTimeout(() => log('really? ', document.querySelector('.' + Iframe.cls)), 1000);
        }

        // log('iframe render document: ', document, this.div);

        return (
            <Fragment>
                {this.div && createPortal(this.props.children, this.div)}
                <iframe
                    src="javascript:void(0);"
                    ref={this.setRef}
                    {...props}
                />
            </Fragment>
        );
    }
}

/**
 * Example
 *
 *
 * scss
 body {
    //background-color: red;
    & > pre {
        display: none;
    }
    input[type="file"] {
        z-index: 1;
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        opacity: 0;
    }
    overflow: hidden;
    &:hover {
        .mask {
            border-color: black;
            color: black;
        }
    }
    .mask {
        position: absolute;
        top: 10%;

        left: 2%;
        width: 96%;

        height: 80%;
        border: 1px dashed gray;
        text-align: center;
        line-height: 27px;
        border-radius: 3px;
    }
}
 * {
    cursor: pointer;
}
 form.hidden {
    display: none;
}



 * js


 import React, { Component, Fragment } from 'react';

 import { render } from 'react-dom';

 import { connect } from 'react-redux';

 import classnames from 'classnames';

 import Iframe from './Iframe';

 import isProd from 'roderic/libs/isProd';

 import {
    Breadcrumb,
    List,
    Button,
    Icon,
    Form,
    Checkbox,
    Loader,
    Modal,
    Header
} from 'semantic-ui-react';

 import './TreeForm.scss';

 class TreeForm extends Component {
    static iframeId = 'iframe-id';
    constructor(...args) {

        super(...args);

        this.state = {
            // text: 'test',
            // test: 'test...',
            sending: false,
            img: false,
            db: false,
            imgerror: false,
        }
    }
    onSubmit = e => {

        // log(e.target.parentNode)
        try {
            // log('trigger submit');
            e.target.parentNode.submit();
        }
        catch (e) {}

        this.setState({
            sending: true,
            imgerror: false,
        });

        // setTimeout(() => {
        //     this.setState({sending: true});
        // }, 500);
    }
    onLoad = () => {

        // log('onload');

        // this is important to repaint again content of iframe
        // this is important to repaint again content of iframe
        // this is important to repaint again content of iframe
        this.setState({
            sending: false,
        });
    }
    beforeAttach = document => {

        let data = false;

        try {

            data = JSON.parse(document.querySelector('pre').innerHTML);
        }
        catch (e) {

            // log('catch: ', e)
        }

        // log('data', data);

        const state = {};

        if (data) {

            if (data.errors && data.errors.length) {

                state.imgerror = data.errors[0];
            }
            else if (data.data && data.data.web && data.data.db) {

                state.img   = data.data.web;
                state.db    = data.data.db;
            }

            Object.keys(state) && this.setState(state);
        }

        // log('state update', state);

    }
    render () {

        const {
            sending,
            img,
            imgerror,
        } = this.state;

        return (
            <div className="tree-form">
                {
                    img ? (
                        <img src={img} height="100" />
                    ) : (
                        <Fragment>
                            <Iframe
                                // name={TreeForm.iframeId}
                                style={{
                                    // border: '1px dashed gray',
                                    border: 'none',
                                }}
                                css={[
                                    '/asset/public/normalize-css/normalize.css',
                                    '/asset/public/semantic-ui-css/semantic.min.css',
                                    '/dist/tree-iframe.bundle.css',
                                ]}
                                onLoad={this.onLoad}
                                beforeAttach={this.beforeAttach}
                                width="300px"
                                height="40px"
                            >
                                {sending && <Loader key="list" active inline='centered' />}
                                <form
                                    method="post"
                                    // target={TreeForm.iframeId}
                                    encType="multipart/form-data"
                                    action={`/endpoint` + (isProd ? `` : `/app_dev.php`) + `/upload-avatar`}
                                    onSubmit={this.onSubmit}
                                    className={classnames({
                                        hidden: sending
                                    })}
                                >
                                    {/*<div>iframe test... {this.state.text}</div>* /}
{/ *<input type="text" value={this.state.text} onChange={e => this.setState({text: e.target.value})} />* /}
<input type="file" name="avatar"
       onChange={e => this.onSubmit(e)}
/>
<div className="mask"><Icon name="cloud upload" /> Drop files to attach, or <a href="javascript:void(0);">browse</a>.</div>
</form>
</Iframe>
{imgerror && <div>Error: {imgerror}</div>}
</Fragment>
)
}
</div>
);
}
}

const mapStateToProps = state => ({
    // username: getUsername(state)
});

const mapDispatchToProps = (dispatch, { match, edit, history, pathAfterSignOut }) => ({
    // loginSignOut() {
    //     return dispatch(actions.loginSignOut(pathAfterSignOut))
    // },
    // requestDiff() {
    //     return dispatch(actions.requestSessionDiff());
    // }
    // onShowNewMessageForm() {
    //     dispatch(actions.treeFormEditShowClearForm());
    // }
});

export default connect(
    mapStateToProps,
    mapDispatchToProps
)(TreeForm);


 */

