
import React, { Component } from 'react';

import PropTypes from 'prop-types';

import { withRouter } from 'react-router';

import node from 'detect-node';

// const getPath = (track = false) => {
export const getPath = (props, state, prevProps, prevState) => {

    try {

        let path = location.href.substring(location.origin.length);

        // if (!track) {

        path = path.split('#')[0];
        // }

        return path;
    }
    catch (e) {

    }

    return '';
};

const routerLifecycle = (WrappedComponent, track = getPath) => {

    class RouterLoader extends Component {
        constructor(...args) {

            super(...args);

            this.state = {
                state: track(this.props, this.state),
            }
        }
        getSnapshotBeforeUpdate(prevProps, prevState) {
            return track(this.props, this.state, prevProps, prevState);
        }
        componentDidUpdate(prevProps, prevState, snapshot) {

            const {
                state,
            } = this.state;

            // log('- componentDidUpdate', prevProps, prevState, snapshot, 'equal', state, '-', snapshot, 'test', state === snapshot, 'all', (state !== false && snapshot !== false && state !== snapshot))

            if (state !== false && snapshot !== false && state !== snapshot) {

                this.setState(
                    {
                        state: false,
                    },
                    () => this.setState({
                        state: snapshot,
                    })
                );
            }
        }
        render() {

            const {
                state,
            } = this.state;

            if ( ! node && ! state ) {

                return null;
            }

            return <WrappedComponent {...this.props} />;
        }
    }

    const component = withRouter(RouterLoader);

    if (typeof WrappedComponent.fetchData === 'function') {

        component.fetchData = WrappedComponent.fetchData;
    }

    return component;
}

export default routerLifecycle;