
module.exports = function (config) {

    if ( ! config ) {

        return log(`redirectionsMiddleware: no config provided`);
    }

    const {
        ignorePrefixes,
        redirections
    } = config;

    const ignorePrefixesLength = ignorePrefixes.length;

    const redirectionsLength = redirections.length;

    return (req, res, next) => {

        const url = req.url;

        for (let i = 0 ; i < ignorePrefixesLength ; i += 1 ) {

            if (url.indexOf(ignorePrefixes[i]) === 0) {

                // log("\nreq.url:     >> pass >>    " + req.url + "\n");

                return next();
            }
        }

        for (let i = 0 ; i < redirectionsLength ; i += 1 ) {

            if (redirections[i].test.test(url)) {

                const newPath = url.replace(redirections[i].test, redirections[i].buildPath);

                // log('test: ', redirections[i].test, url, newPath);

                log(`Redirect path '${url}' to '${newPath}' 301 status code`);

                return res.redirect(301, newPath);
            }
        }

        // log("\nreq.url:     ++ didn't found redirect rule ++    " + req.url + "\n");

        next();
    };
}