

/**
 *
 sound(600, 50);
 sound(500, 150);
 */
var sound = (function () {

    // var log = console.log;
    //
    // var l = (...args) => log(((new Date()).getTime()), 'test: ', ...args);

    var audioCtx = false;

    const getCtx = () => {

        if ( ! audioCtx ) {

            audioCtx = new (window.AudioContext || window.webkitAudioContext)();
        }

        return audioCtx;
    }

    var list = [];

    var working = false;

    var trigger = () => {

        // l('trigger', 'working', working, 'list', list.length)

        if ( list.length ) {

            working = true;

            var k = list.shift().concat([trigger]);

            // log('k', k)

            doSound.apply(this, k);
        }
        else {

            working = false;
        }
    }

    var doSound = (freq, time, callback) => {

        if (freq === false) {

            return callback ? setTimeout(callback, time) : false;
        }

        // l('doSound', freq, time, callback);

        var oscillator = getCtx().createOscillator();
        var gainNode = getCtx().createGain();
        oscillator.connect(gainNode);
        gainNode.connect(getCtx().destination);

        oscillator.type = 'square'; // sine wave — other values are 'square', 'sawtooth', 'triangle' and 'custom'
        oscillator.frequency.value = freq; // value in hertz

        gainNode.gain.value = 0.7;
        oscillator.start();

        // var x = 5; // seconds
        // https://developer.mozilla.org/en-US/docs/Web/API/AudioParam/exponentialRampToValueAtTime
        //gainNode.gain.exponentialRampToValueAtTime(0.00001, getCtx().currentTime + x );
        //gainNode.gain.exponentialRampToValueAtTime(0.00001, getCtx().currentTime + ( time / 1000 ));

        setTimeout(() => {

            // l('callback');

            oscillator.stop();

            callback && callback();

        }, time);
    }


    return (freq, time) => {

        (typeof freq === 'undefined') && (freq = 400);

        (typeof time === 'undefined') && (time = 100);

        list.push([freq, time]);

        // l('added', JSON.stringify(list));

        working || trigger();
    };
}());

module.exports = sound;