/**
 * This file can be loaded from node_modules/roderic
 */

/**
 *
 *
 *
 * https://github.com/krakenjs/jwt-csrf
 *
 *
 *
 *
 */
import * as config from 'public.config';

import env from 'roderic/webpack/dotenv';

env.webload(require('preprocessor/dotenv.json'));

// import 'isomorphic-fetch';
import 'roderic/libs/ajax-fetch';

export const delay = config.delay;

import delayPromise from 'roderic/webpack/delay';

import modeNode from 'detect-node';

let jwtToken;

import isProd from 'roderic/libs/isProd';

/**
 * Shortcut to don't engage second api server to fetch data if data are in static files
 * remove that later if read api with data in db will be implemented vvv
 */
//import { fakeTest, fakeReturn } from './transport-fake';
//
//     let fetchDataDirectly = () => {};
//
//     if (modeNode) {
//
//         const nodePath = eval('require')('path');
//
//         const jsonFilesCacheMiddleware = eval('require')(nodePath.resolve(__dirname, 'libs', 'jsonFilesCacheMiddleware'));
//
//         let regex = jsonFilesCacheMiddleware.regex;
//
//         jsonFilesCacheMiddleware.setup(config.jsonApi);
//
//         fetchDataDirectly = path => {
//
//             if (modeNode) {
//
//                 if (config.jsonApi.inNodeFetchDirectlyFromFiles) {
//
//                     if (regex.test(path)) {
//
//                         var param = path.match(regex)[1];
//
//                         var data = jsonFilesCacheMiddleware.getDataFromJsonFile(param);
//
//                         if (data) {
//
//                             if (data.content) {
//
//                                 // log(`found data by param '${param}' ` + data.status)
//
//                                 return JSON.parse(data.content)
//                             }
//                             else {
//                                 // log(`no 'content' field for param '${param}'`, data);
//                             }
//                         }
//                     }
//                 }
//                 else {
//                     log(`path: ${param}, can't fetch directly, inNodeFetchDirectlyFromFiles disabled`);
//                 }
//             }
//         }
//     }
// // remove that later if read api with data in db will be implemented ^^^

export const setJwtToken = token => jwtToken = token;

let host = false;

/**
 * NODE_DONT_UNDERSTAND_*
 */
let ndur = false;

export const getUrl = (path = '', forceRelative = false) => {

    let sendJWTToken = false;

    if (/^https?:\/\//.test(path)) {

        return { path, sendJWTToken };
    }

    if (host === false) {

        host = '';
        ndur = '';

        if (modeNode) {

            if ( !env.has('NODE_SSR_PROTOCOL') || !env.has('NODE_SSR_HOST') || !env.has('NODE_SSR_PORT') ) {

                throw `Declare all tree environment variables NODE_SSR_PROTOCOL, NODE_SSR_HOST and NODE_SSR_PORT because something is missing`;
            }

            host += env('NODE_SSR_PROTOCOL') + '://' + env('NODE_SSR_HOST');

            if (env('NODE_SSR_PORT') != 80) {

                host += ':' + env('NODE_SSR_PORT');
            }
        }
        else {

            if ( env.has('NODE_CORS_PROTOCOL') || env.has('NODE_CORS_HOST') || env.has('NODE_CORS_PORT') ) {

                if ( !env.has('NODE_CORS_PROTOCOL') || !env.has('NODE_CORS_HOST') || !env.has('NODE_CORS_PORT') ) {

                    throw `Declare all tree environment variables NODE_CORS_PROTOCOL, NODE_CORS_HOST and NODE_CORS_PORT if you declared one of them because something is missing`;
                }

                host += env('NODE_CORS_PROTOCOL') + '://' + env('NODE_CORS_HOST');

                if (env('NODE_CORS_PORT') != 80) {

                    host += ':' + env('NODE_CORS_PORT');
                }
            }
        }

        if ( env.has('NODE_DONT_UNDERSTAND_RELATIVE_PROTOCOL') || env.has('NODE_DONT_UNDERSTAND_RELATIVE_HOST') || env.has('NODE_DONT_UNDERSTAND_RELATIVE_PORT') ) {

            if ( !env.has('NODE_DONT_UNDERSTAND_RELATIVE_PROTOCOL') || !env.has('NODE_DONT_UNDERSTAND_RELATIVE_HOST') || !env.has('NODE_DONT_UNDERSTAND_RELATIVE_PORT') ) {

                throw `Declare all tree environment variables NODE_DONT_UNDERSTAND_RELATIVE_PROTOCOL, NODE_DONT_UNDERSTAND_RELATIVE_HOST and NODE_DONT_UNDERSTAND_RELATIVE_PORT if you declared one of them because something is missing`;
            }

            ndur += env('NODE_DONT_UNDERSTAND_RELATIVE_PROTOCOL') + '://' + env('NODE_DONT_UNDERSTAND_RELATIVE_HOST');

            if (env('NODE_DONT_UNDERSTAND_RELATIVE_PORT') != 80) {

                ndur += ':' + env('NODE_DONT_UNDERSTAND_RELATIVE_PORT');
            }
        }
    }

    // modeNode && console.log('before: ' + path);

    if (config.php_proxy && config.php_proxy.prefix) {

        const match = path.match(config.php_proxy.prefix);

        if (match) {

            if (modeNode) {

                // if node then cut /endpoint
                path = match[2];

                if ( ! isProd ) {

                    path = '/app_dev.php' + path;
                }
            }
            else {

                if ( ( ! isProd ) && match && ( ! /^\/app_dev\.php(\/.*)?$/.test(match[2]) ) ) {

                    path = path.replace(config.php_proxy.prefix, '$1/app_dev.php$2')
                }
            }
        }
    }

    // if ( ( ! isProd ) && ( ! /^\/app_dev\.php(\/.*)?$/.test(path) ) ) {
    //
    //     modeNode && console.log('inside: ');
    //
    //     path = '/app_dev.php' + path;
    // }

    // modeNode && console.log('after: ' + path);

    sendJWTToken = true;

    if (forceRelative) {

        if ( modeNode ) {

            path = ndur + path;
        }

        log('transport (forceRelative): ' + path);

        return { path, sendJWTToken };
    }

    path = host + path;

    log('transport: ' + path);

    return { path, sendJWTToken };
};

export const fetchData = (path, _opt, ...rest) => {

    let promise;

    const {
        node,
        ...opt
    } = _opt;

    const { path: _path, sendJWTToken } = getUrl(path, node);

    opt.sendJWTToken = sendJWTToken;

    if ( opt.sendJWTToken ) {

        opt.headers = Object.assign({}, opt.headers, {
            'X-jwt' : jwtToken
        });
    }

    // if (fakeTest(path)) {
    //
    //     promise = fakeReturn(path);
    // }
    // else {

    const args = [_path, opt, ...rest];

    if (opt && opt.real) {

        if (modeNode) {

            log(`fetchData: can't handle fetch(opt.real) to endpoint '${path}' - it's request in node`); // rare situation - usually pure fetch we gonna need in browser

            promise = server(...args);
        }
        else {

            if (window.fetch) {

                opt.credentials = "same-origin";

                promise = fetch(...args);
            }
            else {

                log(`fetchData: can't handle fetch(opt.real) to endpoint '${path}' - window.fetch doesn't exist`);

                promise = server(...args);
            }
        }
    }
    else {
        promise = server(...args);
    }

    if (typeof opt.always === 'function') {

        promise.then(opt.always, opt.always);
    }

    promise = promise.then(
        res => {

            if (res.ok) {

                return res;
            }

            return new Promise((resolve, reject) => {

                res.json()
                    .catch(() => null)
                    .then(json => {

                        // log.dump('json')
                        // log.dump(json)
                        // log.dump(res.statusText)
                        // log.dump('end...');

                        if (env('WEBPACK_MODE') === 'dev') {

                            let method = '';

                            try {
                                if (args[1].method !== 'get') {

                                    method = ' -X ' + args[1].method.toUpperCase();
                                }
                            }
                            catch (e) {

                            }

                            let data = '';

                            try {

                                if (args[1].body) {

                                    data = ` --data '${args[1].body}'`;
                                }
                            }
                            catch (e) {

                            }

                            console.log(`\ncurl${method} ${args[0]}${data}`);
                        }

                        return reject({
                            req: [...args],
                            res: {
                                status      : res.status,
                                statusText  : res.statusText,
                                json
                            },
                        });
                    })
                ;
            });
        },
        e => {
            return Promise.reject({
                req: [...args],
                res: {
                    status: 'no status',
                    statusText: 'Request failed',
                    json: null,
                }
            })
        }
    );

    // }

    return delayPromise(delay || 0)
        .then(() => promise)
        ;
};

export const ee = (str, times = 2) => {

    if (typeof str !== 'string') {

        throw "ee(): given value is not string: " + JSON.stringify(str);
    }

    while (times !== 0) {

        str = encodeURIComponent(str);

        times -= 1;
    }

    return str;
}

export const dd = (str, times = 2) => {

    if (typeof str !== 'string') {

        throw "dd(): given value is not string: " + JSON.stringify(str);
    }

    while (times !== 0) {

        str = decodeURIComponent(str);

        times -= 1;
    }

    return str;
}


/**
 * Warning in .catch() always expect format:
 *  {
        req: [...args],
        res: {
            status: 'no status',
            statusText: 'Request failed'
        }
    }
 * @param path
 * @param opt
 * @param rest
 * @returns {*|PromiseLike<T>|Promise<T>}
 */
export const fetchJson = (path, opt = {}, ...rest) => {

    // // remove that later if read api with data in db will be implemented vvv
    //     const data = fetchDataDirectly(path);
    //
    //     if (data) {
    //
    //         return Promise.resolve(data);
    //     }
    // // remove that later if read api with data in db will be implemented ^^^

    opt.headers = {
        ...opt.headers,
        Accept: 'application/json',
        'Content-type' : 'application/json; charset=utf-8'
    };

    if (opt.body && typeof opt.body !== 'string') {

        try {
            if ( opt.body instanceof FormData ) {
                // unfortunately i can't put negative here
            }
            else {
                opt.body = JSON.stringify(opt.body);
            }
        }
        catch (e) {
            opt.body = JSON.stringify(opt.body);
        }
    }

    var promise = fetchData(path, opt, ...rest)
        .then(res => res.text())
        .then(text => {

            // decode manually in order to provide better debug informations because standard res.json() sometimes
            // provide error messages like :
            // invalid json response body at http://localhost:98/endpoint/app_dev.php/userprovider reason: Unexpected token t in JSON at position 124< len: 134
            try {

                return JSON.parse(text);
            }
            catch (e) {

                return Promise.reject(`fetchJson: json parse error >>>${e}<<<: \n\n${text}`);
            }
        })
    ;

    return promise;
};

if ( ! modeNode ) {

    window.fetchData    = fetchData;

    window.fetchJson    = fetchJson;

    window.dd           = dd;

    window.ee           = ee;
}



