
const path = require('path');

const launch = require(path.resolve(__dirname, '..', '..', 'driver.js'));

const { getUrlTest, getUrlEnv } = require(path.resolve(__dirname, '..', '..', 'driver.js'));

const config = require('../../config');

describe('005 navigation', async () => {

    let browser, page;

    beforeAll(async () => {

        browser = await launch(true);

        page = await browser.page(true);
    });

    afterAll(async () => {
        await browser.close();
    });

    it('page -> puppeteer', async () => {

        const page = await browser.page(true);

        await page.getServerEnv('/en/test-page');

        // await page.sleepSec(2);

        await page.click('.link-puppeteer');

        // await page.sleepSec(2);

        const text = await page.evaluate((/* one, two, three */) => new Promise(resolve => {

            var inter = setInterval(() => {

                const el = document.querySelector('.puppeteer-test');

                if (el) {

                    clearInterval(inter);

                    resolve({data: el.innerText});
                }

            }, 200);

        })/* , 'one', 'two', { three: 'four' } */);

        expect(text.data).toBe(`Puppeteer: test`);
    });

    // it('404', async () => {
    //
    //     const status = await fetch(getUrlEnv(`/notfound`), {
    //         headers: {
    //             Accept: 'text/html',
    //         }
    //     }).then(res => res.status);
    //
    //     expect(status).toBe(404);
    // });
});