
const path = require('path');

const launch = require(path.resolve(__dirname, '..', '..', 'driver.js'));

const { getUrlTest, getUrlEnv } = require(path.resolve(__dirname, '..', '..', 'driver.js'));

const config = require('../../config');

describe('007 router active class', async () => {

    let browser, page;

    beforeAll(async () => {

        browser = await launch(true);

        page = await browser.page(true);
    });

    afterAll(async () => {
        await browser.close();
    });

    const common = async path => {

        const page = await browser.page(true);

        await page.getServerEnv(path);

        // await page.sleepSec(2);

        // await page.click('.link-puppeteer');

        // await page.sleepSec(2);

        return await page.evaluate((/* one, two, three */) => new Promise(resolve => {

            var inter = setInterval(() => {

                const el = document.querySelectorAll('.main .left ul > li a');

                if (el) {

                    clearInterval(inter);

                    resolve({data: Array.prototype.slice.call(el).map(e => e.getAttribute('class')).join(',')});
                }

            }, 200);

        })/* , 'one', 'two', { three: 'four' } */);
    }

    it('homepage', async () => {

        const text = await common('/en');

        expect(text.data).toBe("link-homepage active,link-en,link-de,link-puppeteer,link-notfound");
    });

    it('test-page', async () => {

        const text = await common('/en/test-page');

        expect(text.data).toBe("link-homepage,link-en active,link-de,link-puppeteer,link-notfound");
    });

    it('puppeteer', async () => {

        const text = await common('/en/puppeteer');

        expect(text.data).toBe("link-homepage,link-en,link-de,link-puppeteer active,link-notfound");
    });

    it('pagenotfound', async () => {

        const text = await common('/pagenotfound');

        expect(text.data).toBe("link-homepage,link-en,link-de,link-puppeteer,link-notfound active");
    });

    // it('404', async () => {
    //
    //     const status = await fetch(getUrlEnv(`/notfound`), {
    //         headers: {
    //             Accept: 'text/html',
    //         }
    //     }).then(res => res.status);
    //
    //     expect(status).toBe(404);
    // });
});